﻿Type=StaticCode
Version=1.60
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	Type AxisData (flipCount As Int, lastPeak As Float,lastValue As Float, timeStamp As Long)
	Dim AxisX As AxisData
	Dim MagnitudeThreshold As Float
	Dim TimeThreshold As Int
	MagnitudeThreshold = 1
	TimeThreshold = 10000 'milliseconds
	Dim CallBackActivity As String
End Sub

Sub HandleSensorEvent(values() As Float)
	CalcAxis(values(0), AxisX)
End Sub

Sub CalcAxis(v As Float, axis As AxisData)
	Dim difference As Float
	difference = v - axis.lastValue
	axis.lastValue = v
	If Abs(difference) > MagnitudeThreshold Then
		If DateTime.Now - axis.timeStamp > TimeThreshold Then
			axis.Initialize 'reset the data
		End If
		If axis.flipCount < 0 Then 
			Log("Shake.CalcAxis - still waiting")
			Return 'this will happen immediately after a "shake" event.
		End If
		If axis.lastPeak = 0 OR (axis.lastPeak < 0 AND difference > 0) OR (axis.lastPeak > 0 AND difference < 0) Then
			axis.flipCount = axis.flipCount + 1
			axis.lastPeak = difference
			axis.timeStamp = DateTime.Now
			If axis.flipCount = 2 Then
				CallSub(CallBackActivity, "ShakeEvent")
				'To avoid repetitive events:
				axis.flipCount = -10
			End If
		Else
			axis.timeStamp = DateTime.Now
		End If
	End If
End Sub